# Contributing to the Keptn

We are thrilled to have you join us as a contributor!
The Keptn is a community-driven project and we
greatly value collaboration.
There are various ways to contribute to the Lifecycle Toolkit, and
all contributions are highly valued.
Please, explore the options below to learn more about how you can
contribute.

## Before you get started

### Code of Conduct

Please make sure to read and observe our
[Code of Conduct](https://github.com/keptn/.github/blob/main/CODE_OF_CONDUCT.md).

* **Create an issue**: If you have noticed a bug, want to contribute features,
or simply ask a question that for whatever reason you do not want to ask in the
[Lifecycle Toolkit Channels in the CNCF Slack workspace](https://cloud-native.slack.com/channels/keptn-lifecycle-toolkit-dev),
please [search the issue tracker](https://github.com/keptn/lifecycle-toolkit/issues?q=something)
to see if someone else in the community has already created a ticket.
If not, go ahead and [create an issue](https://github.com/keptn/lifecycle-toolkit/issues/new).

* **Start contributing**: We also have a list of
[good first issues](https://github.com/keptn/lifecycle-toolkit/issues?q=is%3Aopen+is%3Aissue+label%3A%22good+first+issue%22).
If you want to work on it, just post a comment on the issue.

This document lays out how to get you started in contributing to
Keptn, so please read on.

## How to Start?

If you are worried or don’t know where to start, check out our next section
explaining what kind of help we could use and where you can get involved.
You can reach out with the questions to
[Lifecycle Toolkit Channels](https://cloud-native.slack.com/channels/keptn-lifecycle-toolkit-dev)
on Slack and a mentor will surely guide you!

### Prerequisites

See
[Set up the development environment](https://keptn.sh/stable/docs/contribute/software/dev-environ/)
for information about how to set up an environment
in which you can develop and test software for Keptn.

## Related Technologies

Please check [Related Technologies](https://keptn.sh/stable/docs/contribute/general/technologies/).

## Linter Requirements

Please check [Linter Requirements](https://keptn.sh/stable/docs/contribute/docs/linter-requirements/).

## Working with git

See [Working with Git](https://keptn.sh/stable/docs/contribute/general/git/)

Your PR will usually be reviewed by the Keptn team within a
couple of days, but feel free to let us know about your PR
[via Slack](https://cloud-native.slack.com/channels/keptn-lifecycle-toolkit-dev).

## Developer Certification of Origin (DCO)

All commits must be accompanied by a DCO sign-off.
See
[DCO](https://keptn.sh/stable/docs/contribute/general/dco/)
for more information.
