---
comments: true
---

# Documentation contributions

Keptn documentation source is stored in the same repository
as Keptn software and test code
and is developed using the same practices used for software
and described in the
[General information](../general/index.md) section
of this *Contributing Guide*.

The pages in this section augment the "General" information
with information that is specific to the documentation:

- [Contribution guidelines for documentation](contrib-guidelines-docs.md)
  augments the general
  [Contribution Guidelines](../general/contrib-guidelines-gen.md)
  with guidelines that are only relevant to documentation.
- [Build Documentation Locally](local-building.md)
  tells how to build the documentation locally
  so you can check the formatting, readability, and links
  in your local branch before you push the new content.
- [Markdownlint](markdownlint.md) provides information
  about the linter we use to check the quality of the coding
  in all `.md` files in the repository.
- [Source file structure](source-file-structure.md)
  describes the sections of the documentation
  and how the structure of the published documentation is defined.
- [Coding the docs](code-docs.md) gives some hints
  about the markdown practices used for the Keptn documentation.
- [Spell checker](spell-check.md) describes the spell checker we use
  and gives instructions for resolving errors it finds.
- [Blogs](blog.md) explains the extra steps required
  to contribute a blog to the Keptn page.
- [Published doc structure](publish.md) explains
  the branches (`stable` and `latest`) for the published documentation.
- [Word list](word-list.md) provides some information about the proper
  use of Keptn and Kubernetes terms in the documentation
  as well as links to other documents with more comprehensive word lists.
