---
comments: true
---

# General information about contributing

This section includes information that applies
to all types of contributions --
software, documentation, and tests:

- [Technologies and concepts you should know](technologies.md)
  gives links to resources you can use to increase your knowledge if necessary.

- [Codespaces](codespace.md) tells how to use GitHub Codespaces
  to contribute to Keptn.
  This is useful for Windows users who may find it difficult
  to install a local development environment
  and for Linux and MacOS users who may want to easily make a small contribution
  without having to set up a full local environment.

- [Working with Git](git/index.md) summarizes the steps required
  to fork and clone a local copy of the repository,
  create a local branch where you create your new content,
  then submit that content as a PR
  then shepherd that PR through the review process until it is merged.

- [Contribution guidelines](contrib-guidelines-gen.md) summarizes
  practices to help you succeed as a contributor.
  These guidelines apply to all contributions;
  a list of additional guidelines that apply only to documentation contributions
  is given in
  [Contribution guidelines for documentation](../docs/contrib-guidelines-docs.md).

- [Refinement Process](refinement-guide.md)
  explains how proposed issues are evaluated and approved for action.

- [Release Checklist](release-checklist.md)
  is a list of tasks that must be created when releasing a new Keptn version.
