---
comments: true
---

# Refinement process

During the Refinement timeblock in community meetings, maintainers engage in technical
discussions on open issues and pull requests.
This dedicated time allows for in-depth conversations, knowledge sharing,
and collective decision-making.
It is an opportunity for the team to synchronize their understanding of
ongoing developments, address challenges, and ensure a common vision for the project.

**Purpose and goals:**

- **Alignment:** Ensure a shared understanding among maintainers regarding ongoing
developments, project goals, and upcoming tickets.
- **Technical Depth:** Delve into the technical aspects of open issues and pull
requests, facilitating a deeper understanding of proposed Pull requests.
- **Decision-Making:** Make collective decisions on the adoption of new features,
changes, and improvements based on technical merit.

This process aligns with our commitment to open-source principles, ensuring that
technical discussions are inclusive, transparent, and beneficial for the
entire Keptn community.

## Contributor guidance

Contributors proposing new features are encouraged to participate in
refinement sessions during [community meetings](https://community.cncf.io/keptn-community/) to talk
about their contributions.
This provides valuable insights into ongoing technical discussions and
aligns their efforts with the broader project vision.
Follow these steps:

1. Review the project's [contributing guide](../index.md)
for information on upcoming refinement meetings.
1. Attend relevant refinement meetings to present and discuss proposed features.
1. Actively engage in technical discussions, seeking feedback and guidance from
maintainers.
1. Iteratively refine contributions based on insights gained during meetings.

By following this process, contributors contribute not only code but also valuable
perspectives and insights, fostering a collaborative and innovative
community environment.

## Outcome

- Shared understanding among maintainers and contributors on ongoing developments.
- Improved contributions via collaborative discussions and refinement.
- Documented decisions and action items for future reference in project documentation.

This refined process aligns with our commitment to open-source principles, ensuring
transparency, inclusivity, and technical excellence within the Keptn community.
