---
comments: true
---

# Contributing to Keptn

Keptn software and documentation
is developed and maintained by the Keptn community.
We invite you to join us.
This guide provides instructions and guidelines
for contributing software, documentation, and tests to Keptn.

Keptn software, documentation, and tests are stored in the same
[Keptn](https://github.com/keptn/lifecycle-toolkit)
GitHub repository.
We use similar processes for all contributions.

This guide provides useful information about how to contribute to the Keptn project.
It is divided into three sections:

* [General](general/index.md) includes information
  that is relevant to all contributions, including
  information you should know about the technologies used,
  instructions for creating a PR that contains your contribution
  by either forking and cloning the repo and creating contributions locally
  or working in Github Codespaces,
  and guidelines that apply to all contributions.

* [Software contributions](software/index.md)
  includes information about how to set up an environment
  for developing and testing Keptn software
  as well as specific instructions for creating a new
  Keptn metrics provider.

* [Documentation contributions](docs/index.md)
  gives additional guidelines that apply only to documentation contributions
  and describes the documentation file structure
  and the documentation tools we use.

* [Website contributions](website/index.md)
  provides relevant information for contributing
  to the website, including all the file directories and
  files used to modify the website, and instructions for
  testing and verifying changes before submitting.
