---
comments: true
---

# Contribute to the Website

This section provides information on how to contribute to the website.

## Location of Files Used to Modify the Website

Here are some key files and directories:

- **`docs/assets/`**: This directory contains all the stylesheets and
javascript files.
- **`docs/overrides/`**: This directory contains all the html files.
- **`mkdocs.yml`**: The main configuration file for MkDocs.
It defines the structure and configuration of the documentation site.

## How to Test/Verify Changes

To test and verify changes before submitting:

- Make your changes in a new branch.
- Open a pull request.
- The changes will be reflected in the ReadTheDocs preview for the PR.
- Review the preview to ensure your changes are correct.

## Building the Website Locally

To see your changes live on your local machine, follow the steps described in the
[Building Documentation Locally](../docs/local-building.md) guide.
This guide provides detailed instructions on how to set up a local MkDocs build
environment.
