---
comments: true
---

# Guides

This section provides comprehensive guides about specific features of Keptn.

## Metrics

- [Keptn Metrics](evaluatemetrics.md) - Explore metrics tracking and monitoring capabilities
in Keptn.
- [DORA Metrics](dora.md) - Elevate deployment efficiency with key measurements like frequency
and lead time, seamlessly managed and monitored within Keptn.

## Observability

- [OpenTelemetry Observability](otel.md) - Achieve end-to-end traceability and observability
in Kubernetes deployments.
- [Context Metadata](metadata.md) - Understand how to enhance traceability and context
awareness by adding metadata to applications, workloads, and tasks.

## Deployment Tasks

- [Deployment Tasks with Keptn](tasks.md) - Understand Deployment Tasks in Keptn, including pre and
post-deployment tasks, to automate and streamline your deployment processes.
- [Redeploy/Restart an Application](restart-application-deployment.md) - Learn how to redeploy
or restart applications using Keptn.

## Analysis

- [Analysis with Keptn](slo.md) - Validate your deployments with Keptn Analysis using SLIs and SLOs.
- [Evaluations in Keptn](evaluations.md) - Discover how Keptn conducts evaluations to assess the
performance and quality of your deployments.

## Auto App Discovery

- [Auto App Discovery](auto-app-discovery.md) - Learn how Keptn automates workload aggregation
with Auto App Discovery
- [Integrate Keptn with Your Applications](integrate.md) - Guide on integrating Keptn with
your applications for streamlined deployment and monitoring.

## Multi-Stage Application Delivery

- [Multi-Stage Application Delivery](multi-stage-application-delivery.md) - Discover how to
deploy applications across multiple stages with Keptn, ensuring consistency and reliability
across different environments.
