---
comments: true
---

# Reference

Welcome to the Keptn documentation reference section,
which provides comprehensive information about the Keptn Custom Resource Definitions (CRDs) and APIs used in Keptn.

## CRD Reference

While the [API Reference](./api-reference/index.md) caters to advanced users with detailed technical specifications,
the CRD Reference serves as a more user-friendly alternative.
It presents the same information found in the API Reference but in a format
that is particularly useful for individuals who are not extremely advanced users.
While many resources are automatically populated,
the CRD Reference guides you through the manual steps for specific manifests.

For a comprehensive list of all Keptn resources, see the [API Reference](./api-reference/index.md).

## API Reference

The [API Reference](./api-reference/index.md) is content that is auto-generated from source code
and offers insights into the structure,
versioning, and functionality of Keptn APIs.

Each API corresponds to an object in our API library, following Kubernetes API versioning.
Keptn APIs extend the base Kubernetes API with additional objects and functionality.
Notably, Keptn generates many of its resources automatically, minimizing the need for manual input.

## Learn more

To learn more about CRDs, APIs, and Kubernetes objects, consult the Kubernetes documentation:

* [API Overview](https://kubernetes.io/docs/reference/using-api/)
* [Custom Resources](https://kubernetes.io/docs/concepts/extend-kubernetes/api-extension/custom-resources/)
* [API versioning](https://kubernetes.io/docs/reference/using-api/#api-versioning)
* [Understanding Kubernetes Objects](https://kubernetes.io/docs/concepts/overview/working-with-objects/kubernetes-objects/)
